#!/usr/sbin/dtrace -Zs
/*
 * js_exec.d - JavaScript Script execution events using DTrace.
 *             Written for the Solaris Nevada DTrace JavaScript provider.
 *
 * 14-Sep-2006, ver 0.70
 *
 * USAGE: js_exec.d
 *
 * This measures when JavaScript performs an execute operation on code,
 * which happens when .js files are run, when embedded code is first run,
 * and timeout events.
 */
/*
 * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */
#pragma ident	"@(#)js_exec.d	1.1	06/09/15 SMI"

#pragma D option quiet
#pragma D option switchrate=10hz

dtrace:::BEGIN
{
	printf("%-20s %32.32s:%s\n", "TIME", "FILE", "LINENO");
}

javascript*:::execute-done
{
	printf("%-20Y %32s:%d\n", walltimestamp, basename(copyinstr(arg0)),
	    arg1);
}
