#!/usr/sbin/dtrace -Zs
/*
 * js_funccalls.d - measure JavaScript function calls using DTrace.
 *                  Written for the Solaris Nevada DTrace JavaScript provider.
 *
 * 12-Sep-2006, ver 0.90
 *
 * USAGE: js_calls.d		# hit Ctrl-C to end
 *
 * FIELDS:
 *              FILE		Filename that contained the function
 *              FUNC		JavaScript function name
 *              CALLS		Function calls during this sample
 */
/*
 * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */
#pragma ident	"@(#)js_funccalls.d	1.1	06/09/15 SMI"

#pragma D option quiet

dtrace:::BEGIN
{
	printf("Tracing... Hit Ctrl-C to end.\n");
}

javascript*:::function-entry
{
	@funcs[basename(copyinstr(arg0)), copyinstr(arg2)] = count();
}

dtrace:::END
{
	printf(" %-32s %-36s %8s\n", "FILE", "FUNC", "CALLS");
	printa(" %-32s %-36s %@8d\n", @funcs);
}
