#!/usr/sbin/dtrace -Zs
/*
 * js_objnew.d - measure JavaScript new objects using DTrace.
 *               Written for the Solaris Nevada DTrace JavaScript provider.
 *
 * 12-Sep-2006, ver 0.80
 *
 * USAGE: js_objnew.d		# hit Ctrl-C to end
 *
 * FIELDS:
 *              FILE		Filename that contained the function
 *              CLASS		Class to which this new object belongs
 *              COUNT		Number of objects created
 */
/*
 * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */
#pragma ident	"@(#)js_objnew.d	1.1	06/09/15 SMI"

#pragma D option quiet

dtrace:::BEGIN
{
	printf("Tracing... Hit Ctrl-C to end.\n");
}

javascript*:::object-create
{
	@objs[basename(copyinstr(arg0)), copyinstr(arg1)] = count();
}

dtrace:::END
{
	printf(" %-24s %-36s %8s\n", "FILE", "CLASS", "COUNT");
	printa(" %-24.24s %-36s %@8d\n", @objs);
}
