#!/usr/sbin/dtrace -Zs
/*
 * js_objs.d - snoop JavaScript Object creation using DTrace.
 *             Written for the Solaris Nevada DTrace JavaScript provider.
 *
 * 14-Sep-2006, ver 0.80
 *
 * USAGE: js_objs.d		# hit Ctrl-C to end
 *
 * FIELDS:
 *              TIME		Time string
 *              FILE		Filename that contained the function
 *              LINENO		File line number where object was created
 *              CLASS		Class to which this new object belongs
 */
/*
 * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */
#pragma ident	"%Z%%M%	%I%	%E% SMI"

#pragma D option quiet

dtrace:::BEGIN
{
	printf("%-20s %24s:%-7s %s\n", "TIME", "FILE", "LINENO", "CLASS");
}

javascript*:::object-create
/arg2/
{
	printf("%-20Y %24.24s:%-7d %s\n", walltimestamp, 
	    basename(copyinstr(arg0)), (int)arg3, copyinstr(arg1));
}
